;   quirky 8th rest - scratching head
;   5-20-2008 by J.P. Shankle
;  This WON'T build a solid line of 8th tails across the screen in Vista
;  This WILL build a solid line of 8th tails across the screen in XP
;  Eighthtail, eighthrest and quarterrest are includes I wrote to make these
;  figures on the musical page. They employ SetPixel and as the test shows
;  work in other positions in Vista.

.686
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\winmm.inc
include \masm32\eighthtail\eighthtail.inc
include \masm32\eighthrest\eighthrest.inc
include \masm32\quarterrest\quarterrest.inc
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\eighthtail\eighthtail.lib
includelib \masm32\eighthrest\eighthrest.lib
includelib \masm32\quarterrest\quarterrest.lib

WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
cxClient               dd   0               ; mouse x value
cyClient              dd   0               ; mouse y value
cyclient2            dd   0
cyclientT            dd   0               ; y - top   
cyclientB           dd   0               ; y - bottom
holdleft            dd   0
holdleft2         dd   0
holdright         dd   0
holdbottom          dd   0
savebottom         dd   0
savemiddleofX     dd   0
topdown             dd   0
topdown2          dd   0
horz                  dd  0
AppName             db   "Test of 8th Note Tail and others",0
szDisplayName    db   "Test of 8th Note Tail and others",0
T1                        db '??????????????????????',0
T4                        db  '123456789012345678901234567890123456789012345678901234567890',0
msg1                   db  'The errors are below the question marks and straight down the screen.',0
msg2                   db  'These omissions only occur in Vista. The question mark areas are filled in XP.',0
 
.data?
CommandLine LPSTR     ?
hFile       HANDLE    ? 
hInstance   dd        ?
RR          RECT      {?}
 
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX, msg: MSG, hwnd: HWND, hBrush: DWORD, hdc: HDC
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
 	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInst
	pop   wc.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
            invoke LoadCursor, NULL,IDC_ARROW
	mov   wc.hCursor, eax
	invoke CreateSolidBrush, 00ff0000h          
            mov   hBrush, eax
	mov   wc.hbrBackground, eax 
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, OFFSET szDisplayName
	mov   wc.hIconSm, 0
	invoke RegisterClassEx, addr wc
            invoke SystemParametersInfo, SPI_GETWORKAREA, 0, addr RR, 0       
            mov eax, RR.top
            mov topdown, eax
            mov eax, RR.left
            mov holdleft, eax
           mov eax, RR.right
           mov holdright, eax      
          mov eax, RR.bottom
          mov holdbottom, eax
          push edx               ;  this code sets up cxclient/cyclient for all chords 
         push ebx
         xor edx, edx     
         mov eax, holdright     ; find middle of line 
        mov ebx, 2                
        div ebx
        mov savemiddleofX, eax  ; middle of screen - save for all chords
        pop ebx
        pop edx
	INVOKE CreateWindowEx, NULL, ADDR szDisplayName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW, RR.left, RR.top, RR.right,\
           RR.bottom, NULL, NULL, hInst, NULL       
  	mov   hwnd, eax
	INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
      StartLoop:
          INVOKE GetMessage, ADDR msg, NULL, 0, 0
          cmp eax, 0
          je ExitLoop 
          INVOKE TranslateMessage, ADDR msg
          INVOKE DispatchMessage, ADDR msg
          jmp StartLoop
       ExitLoop: 
          mov eax, msg.wParam
          ret           
WinMain ENDP

WndProc PROC  hWnd:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM 
        LOCAL hdc: HDC, hInst: HINSTANCE, ps:PAINTSTRUCT, hBrush: dword 
        invoke GetDC,hWnd
        mov hdc, eax            
                      
     .IF iMsg==WM_PAINT
         invoke BeginPaint, hWnd, ADDR ps
         mov hdc, eax 
         invoke CreateSolidBrush, 0000ffffh         
         mov hBrush, eax
         invoke SelectObject, hdc, hBrush
         invoke Rectangle, hdc, 0, 0, holdright, holdbottom     ; full yellow rectangle
         invoke SelectObject, hdc, eax
         invoke DeleteObject, hBrush         
          
         invoke CreateSolidBrush, 00000000h          ; black
         mov hBrush, eax
         invoke SelectObject, hdc, hBrush
         
; build line across screen
; eighttail is my module to create an 8th note tail using SetPixel
        add horz, 5
        xor esi, esi
         .while esi < 90
            invoke tail8, hdc,  horz, 100                     ; eight note tail
            add horz, 12
            inc esi
         .endw
         
; eightrest is my module to create an 8th rest using SetPixel
        mov horz, 0
        xor esi, esi
         .while esi < 85
            invoke eighthr, hdc,  horz, 40                     ; eight rest
            add horz, 15
            inc esi
         .endw
         
; quarterrest is my module to create a quarter rest using SetPixel
        mov horz, 0
        xor esi, esi
         .while esi < 85
            invoke quartr, hdc,  horz, 75                     ; quarter rest
            add horz, 15
            inc esi
         .endw

         invoke SetBkMode, hdc, TRANSPARENT
         invoke TextOut, hdc, 280, 70, ADDR T1, 21       
         invoke TextOut, hdc, 800, 70, ADDR T1, 21       
         invoke TextOut, hdc, 5, 250, ADDR T4, 60       
         invoke TextOut, hdc, 545 ,250, ADDR T4, 60                
         invoke TextOut, hdc, 100 ,300, ADDR msg1, 69                
         invoke TextOut, hdc, 100 ,330, ADDR msg2, 78                 
      ; end build line across screen
      
         invoke SelectObject, hdc, eax
         invoke DeleteObject, hBrush
         
   .ELSEIF iMsg==WM_DESTROY
         invoke ReleaseDC, hWnd, hdc
         invoke PostQuitMessage,NULL
         ret 0
   .ENDIF
      invoke DefWindowProc, hWnd, iMsg, wParam, lParam
	ret
WndProc ENDP

end start
